/*
   Small library of useful utilities based on the dietlib by fefe
   Copyright (C) 2003, 2008 Andreas Franz Borchert
   --------------------------------------------------------------------
   This library is free software; you can redistribute it and/or modify
   it under the terms of the GNU Library General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with this library; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef AFBLIB_MULTIPLEXOR_H
#define AFBLIB_MULTIPLEXOR_H

#include <stdbool.h>

typedef struct output_queue_member {
   char* buf;
   unsigned int len;
   unsigned int pos;
   struct output_queue_member* next;
} output_queue_member;

typedef struct connection {
   int fd;
   void* handle; /* may be freely used by the application */
   void* mpx_handle; /* corresponding parameter from run_multiplexor */
   bool eof;
   output_queue_member* oqhead;
   output_queue_member* oqtail;
   struct connection* next;
   struct connection* prev;
} connection;

typedef void (*input_handler)(connection* link, char* buf, unsigned int len);
typedef void (*close_handler)(connection* link);

void run_multiplexor(int socket, input_handler ihandler,
   close_handler chandler, void* mpx_handle);
int write_to_link(connection* link, char* buf, unsigned int len);
void close_link(connection* link);

#endif
